<?php
namespace FiloBlu\Popup\Model\Popup;

use FiloBlu\Popup\Model\ResourceModel\Popup\CollectionFactory;
use Magento\Ui\DataProvider\AbstractDataProvider;

class DataProvider extends \Magento\Ui\DataProvider\AbstractDataProvider
{
    /**
     * @param string $name
     * @param string $primaryFieldName
     * @param string $requestFieldName
     * @param CollectionFactory $contactCollectionFactory
     * @param array $meta
     * @param array $data
     */

     protected $_helper;

    public function __construct(
        $name,
        $primaryFieldName,
        $requestFieldName,
        CollectionFactory $contactCollectionFactory,
        \FiloBlu\Popup\Helper\Data $helper,
        array $meta = [],
        array $data = []
    ) {
        $this->collection = $contactCollectionFactory->create();
        $this->_helper = $helper;
        parent::__construct($name, $primaryFieldName, $requestFieldName, $meta, $data);

    }

    public function getData()
    {
        if (isset($this->loadedData)) {
            return $this->loadedData;
        }

        $items = $this->collection->getItems();

        $this->loadedData = array();
        /** @var popup_details $popup_details */
        foreach ($items as $popup_details) {
            // our fieldset is called "popup_details" or this table so that magento can find its datas:
            $this->loadedData[$popup_details->getId()]= $popup_details->getData();
            if ($this->loadedData[$popup_details->getId()]["image"])
            {
                $imgName = $this->loadedData[$popup_details->getId()]["image"] ;
                $this->loadedData[$popup_details->getId()]["image"] = [];
                $this->loadedData[$popup_details->getId()]["image"][0]['name'] = $imgName;

                $imgUrl = $this->_helper->getImageUrl($imgName);
                $this->loadedData[$popup_details->getId()]["image"][0]['url'] = $imgUrl;
            }
          }


        return $this->loadedData;

    }


}
